Index: configure
===================================================================
--- configure	(revision 604)
+++ configure	(working copy)
@@ -73,7 +73,7 @@
     ;;
   darwin*)
     SYS="MACOSX"
-    CFLAGS="$CFLAGS -falign-loops=16"
+    CFLAGS="$CFLAGS -falign-loops=16 -fno-common"
     LDFLAGS="$LDFLAGS -lm -lmx"
     ;;
   freebsd*)
@@ -245,7 +245,8 @@
             ;;
         --enable-shared)
             shared="yes"
-            if [ $ARCH = "X86_64" -o $ARCH = "PPC" -o $ARCH = "ALPHA" ] ; then
+            if [ $ARCH = "X86_64" -o $ARCH = "PPC" -o $ARCH = "ALPHA" -o $SYS = "MACOSX" ]
+	    then
                 pic="yes"
             fi
             ;;
@@ -364,7 +365,11 @@
 
 if [ "$shared" = "yes" ]; then
     API=$(grep '#define X264_BUILD' < x264.h | cut -f 3 -d ' ')
-    echo "SONAME=libx264.so.$API" >> config.mak
+    if [ "$SYS" = "MACOSX" ]; then
+        echo "SONAME=libx264.$API.dylib" >> config.mak
+    else
+        echo "SONAME=libx264.so.$API" >> config.mak
+    fi
     echo 'default: $(SONAME)' >> config.mak
     if [ "$gtk" = "yes" ]; then
         echo "SONAMEGTK=libx264gtk.so.$API" >> gtk/config.mak
Index: Makefile
===================================================================
--- Makefile	(revision 604)
+++ Makefile	(working copy)
@@ -71,7 +71,11 @@
 	ranlib libx264.a
 
 $(SONAME): .depend $(OBJS) $(OBJASM)
+ifeq ($(SYS),MACOSX)
+	$(CC) -dynamiclib -o $@ $(OBJS) $(OBJASM) $(LDFLAGS)
+else
 	$(CC) -shared -o $@ $(OBJS) $(OBJASM) -Wl,-soname,$(SONAME) $(LDFLAGS)
+endif
 
 x264$(EXE): $(OBJCLI) libx264.a 
 	$(CC) -o $@ $+ $(LDFLAGS)